---
title: Create WhatsApp Delivery Settings
description: This example uses PUT environments/{{envID}}/notificationsSettings/instantMessagingDeliverySettings/whatsApp to configure a WhatsApp account to use for PingOne notifications.
component: pingone-api
page_id: pingone-api:platform:notifications/instant-messaging-delivery-settings/create_whatsapp_delivery_settings
canonical_url: https://developer.pingidentity.com/pingone-api/platform/notifications/instant-messaging-delivery-settings/create_whatsapp_delivery_settings.html
section_ids:
  prerequisites: Prerequisites
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Create WhatsApp Delivery Settings

##

```none
PUT {{apiPath}}/v1/environments/{{envID}}/notificationsSettings/instantMessagingDeliverySettings/whatsApp
```

This example uses `PUT environments/{{envID}}/notificationsSettings/instantMessagingDeliverySettings/whatsApp` to configure a WhatsApp account to use for PingOne notifications.

### Prerequisites

* Refer to [Notifications](../../notifications.html) and [Instant Messaging Delivery Settings](../instant-messaging-delivery-settings.html) for important overview information.

> **Collapse: Request Model**
>
> | Property                    | Type   | Required? |
> | --------------------------- | ------ | --------- |
> | `appId`                     | String | Required  |
> | `appSecret`                 | String | Required  |
> | `provider`                  | String | Required  |
> | `userAccessToken`           | String | Required  |
> | `whatsAppAccountBusinessId` | String | Required  |
>
> Refer to the [Instant messaging delivery settings data model](../instant-messaging-delivery-settings.html) for full property descriptions.

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "provider":"CUSTOM_WHATSAPP",
    "whatsAppAccountBusinessId": "{{whatsAppBusinessID}}",
    "appId":"{{whatsAppAppID}}",
    "userAccessToken":"{{whatsAppToken}}",
    "appSecret":"{{whatsAppSecret}}"
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff --request PUT '{{apiPath}}/v1/environments/{{envID}}/notificationsSettings/instantMessagingDeliverySettings/whatsApp' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "provider":"CUSTOM_WHATSAPP",
    "whatsAppAccountBusinessId": "{{whatsAppBusinessID}}",
    "appId":"{{whatsAppAppID}}",
    "userAccessToken":"{{whatsAppToken}}",
    "appSecret":"{{whatsAppSecret}}"
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/notificationsSettings/instantMessagingDeliverySettings/whatsApp")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Put);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""provider"":""CUSTOM_WHATSAPP""," + "\n" +
@"    ""whatsAppAccountBusinessId"": ""{{whatsAppBusinessID}}""," + "\n" +
@"    ""appId"":""{{whatsAppAppID}}""," + "\n" +
@"    ""userAccessToken"":""{{whatsAppToken}}""," + "\n" +
@"    ""appSecret"":""{{whatsAppSecret}}""" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/notificationsSettings/instantMessagingDeliverySettings/whatsApp"
  method := "PUT"

  payload := strings.NewReader(`{
    "provider":"CUSTOM_WHATSAPP",
    "whatsAppAccountBusinessId": "{{whatsAppBusinessID}}",
    "appId":"{{whatsAppAppID}}",
    "userAccessToken":"{{whatsAppToken}}",
    "appSecret":"{{whatsAppSecret}}"
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
PUT /v1/environments/{{envID}}/notificationsSettings/instantMessagingDeliverySettings/whatsApp HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "provider":"CUSTOM_WHATSAPP",
    "whatsAppAccountBusinessId": "{{whatsAppBusinessID}}",
    "appId":"{{whatsAppAppID}}",
    "userAccessToken":"{{whatsAppToken}}",
    "appSecret":"{{whatsAppSecret}}"
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"provider\":\"CUSTOM_WHATSAPP\",\n    \"whatsAppAccountBusinessId\": \"{{whatsAppBusinessID}}\",\n    \"appId\":\"{{whatsAppAppID}}\",\n    \"userAccessToken\":\"{{whatsAppToken}}\",\n    \"appSecret\":\"{{whatsAppSecret}}\"\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/notificationsSettings/instantMessagingDeliverySettings/whatsApp")
  .method("PUT", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/notificationsSettings/instantMessagingDeliverySettings/whatsApp",
  "method": "PUT",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "provider": "CUSTOM_WHATSAPP",
    "whatsAppAccountBusinessId": "{{whatsAppBusinessID}}",
    "appId": "{{whatsAppAppID}}",
    "userAccessToken": "{{whatsAppToken}}",
    "appSecret": "{{whatsAppSecret}}"
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'PUT',
  'url': '{{apiPath}}/v1/environments/{{envID}}/notificationsSettings/instantMessagingDeliverySettings/whatsApp',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "provider": "CUSTOM_WHATSAPP",
    "whatsAppAccountBusinessId": "{{whatsAppBusinessID}}",
    "appId": "{{whatsAppAppID}}",
    "userAccessToken": "{{whatsAppToken}}",
    "appSecret": "{{whatsAppSecret}}"
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/notificationsSettings/instantMessagingDeliverySettings/whatsApp"

payload = json.dumps({
  "provider": "CUSTOM_WHATSAPP",
  "whatsAppAccountBusinessId": "{{whatsAppBusinessID}}",
  "appId": "{{whatsAppAppID}}",
  "userAccessToken": "{{whatsAppToken}}",
  "appSecret": "{{whatsAppSecret}}"
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("PUT", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/notificationsSettings/instantMessagingDeliverySettings/whatsApp');
$request->setMethod(HTTP_Request2::METHOD_PUT);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "provider":"CUSTOM_WHATSAPP",\n    "whatsAppAccountBusinessId": "{{whatsAppBusinessID}}",\n    "appId":"{{whatsAppAppID}}",\n    "userAccessToken":"{{whatsAppToken}}",\n    "appSecret":"{{whatsAppSecret}}"\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/notificationsSettings/instantMessagingDeliverySettings/whatsApp")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Put.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "provider": "CUSTOM_WHATSAPP",
  "whatsAppAccountBusinessId": "{{whatsAppBusinessID}}",
  "appId": "{{whatsAppAppID}}",
  "userAccessToken": "{{whatsAppToken}}",
  "appSecret": "{{whatsAppSecret}}"
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"provider\":\"CUSTOM_WHATSAPP\",\n    \"whatsAppAccountBusinessId\": \"{{whatsAppBusinessID}}\",\n    \"appId\":\"{{whatsAppAppID}}\",\n    \"userAccessToken\":\"{{whatsAppToken}}\",\n    \"appSecret\":\"{{whatsAppSecret}}\"\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/notificationsSettings/instantMessagingDeliverySettings/whatsApp")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "PUT"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.eu/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/notificationsSettings/instantMessagingDeliverySettings/whatsApp"
        },
        "environment": {
            "href": "https://api.pingone.eu/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        }
    },
    "id": "7d9b2232-7589-4721-8381-1aa848c4030c",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "createdAt": "2024-09-19T09:19:02.448Z",
    "updatedAt": "2024-09-19T09:19:02.448Z",
    "provider": "CUSTOM_WHATSAPP",
    "type": "WHATSAPP",
    "whatsAppAccountBusinessId": "107794359053209",
    "appId": "263386889724299",
    "numbers": [
        {
            "type": "WHATSAPP",
            "selected": true,
            "available": true,
            "createdAt": "2024-09-19T09:19:03.768Z",
            "number": "+1 555-061-2978",
            "capabilities": [
                "WHATSAPP"
            ],
            "numberId": "116195731537720",
            "verifiedName": "Test Number",
            "qualityRating": "GREEN"
        }
    ],
    "status": "Pending"
}
```
